#!/usr/local/bin/perl
use strict;
#
# T Robert Wyatt (USA)	c Xephon 2002
#
# IBM Recommended Values
my %StdParm = (
    msgmap => 1026,
    msgmax => 4096,
    msgmnb => 4096,
    msgmni => 50,
    msgseg => 2048,
    msgssz => 8,
    msgtql => 1024,
    semaem => 16384,
    semmap => 1026,
    semmni => 1024,
    semmns => 32767,
    semmnu => 2048,
    semmsl => 128,
    semopm => 128,
    semume => 256,
    semvmx => 32767,
    shmmax => 4194304,
    shmmni => 1024,
    shmseg => 1024,
    );
# Declare hashes to store system values
my %Sysdef = ();
my %EtcSystem = ();
# Only  valid for SunOS
my $OS = `uname`;
die "$0: Not a Solaris server $OS\n" unless $OS eq
"SunOS\n";
# Go get values from /etc/system
open(SYSTM, "</etc/system") or die "$0: No /etc/system
file found\n";
while (<SYSTM>) {
    chomp;
    s/\s*//g;
    my @Foo = split /[_=]/;
    my ($Value, $Parm) = reverse @Foo;
    $EtcSystem{$Parm} = $Value if $StdParm{$Parm};
}
close SYSTM;
# Go get values from sysdef -i
foreach (`/etc/sysdef -i`) {
    chomp;
    s/^\s*//;
    s/\)//g;
    my @Bar = split /[\s(]/;
    my ($Value) = @Bar;
    my $Parm = lc(pop @Bar);
    $Sysdef{$Parm} = $Value if $StdParm{$Parm};
}
# Print values
#
print "Parm\tStd\tSysdef\t/etc\n";
foreach (sort keys %StdParm) {
    print "$_\t$StdParm{$_}\t", 
        exists $Sysdef{$_} ? $Sysdef{$_} : "none",
        "\t",
        exists $EtcSystem{$_} ? $EtcSystem{$_} : "none";
    my $Greatest =  $Sysdef{$_} > $EtcSystem{$_} ?
$Sysdef{$_} : $EtcSystem{$_};
    print "\tLOW!" if $Greatest < $StdParm{$_};
    print "\n";
}

